#include <machine/asmacros.h>
#include <machine/fpudrop.h>


.text


	ALIGN_TEXT
generic_onfault:
	addl	$4,%esp
	ret


	ALIGN_TEXT
fpu_onfault:
	FPU_UNDROP
	addl	$8,%esp
	ret


	ALIGN_TEXT
UNPIN_JMP(%eax,memcpy)


	SUPERALIGN_TEXT
ENTRY(generic_memcpy)
	pushl	$generic_onfault
	movl	%ecx,%eax
	shrl	$2,%ecx
	cld
	rep
	movsl
	movl	%eax,%ecx
	andl	$3,%ecx
	rep
	movsb
	addl	$4,%esp
	ret


	SUPERALIGN_TEXT
ENTRY(mmx_memcpy)
	FPU_DROP(2048,memcpy)
	pushl	$fpu_onfault

	movl	%ecx,%eax
	shrl	$6,%ecx
	SUPERALIGN_TEXT
1:
	movq	(%esi),%mm0
	movq	8(%esi),%mm1
	movq	16(%esi),%mm2
	movq	24(%esi),%mm3
	movq	32(%esi),%mm4
	movq	40(%esi),%mm5
	movq	48(%esi),%mm6
	movq	56(%esi),%mm7
	movq	%mm0,(%edi)
	movq	%mm1,8(%edi)
	movq	%mm2,16(%edi)
	movq	%mm3,24(%edi)
	movq	%mm4,32(%edi)
	movq	%mm5,40(%edi)
	movq	%mm6,48(%edi)
	movq	%mm7,56(%edi)
	addl	$64,%edi
	addl	$64,%esi
	loop	1b

	movl	%eax,%ecx
	andl	$63,%ecx
	shrl	$2,%ecx
	cld
	rep
	movsl
	movl	%eax,%ecx
	andl	$3,%ecx
	rep
	movsb

	addl	$4,%esp
	FPU_UNDROP
	ret



	ALIGN_TEXT
ENTRY(bcopyb)
	pushl	%esi
	pushl	%edi
	movl	12(%esp),%esi
	movl	16(%esp),%edi
	movl	20(%esp),%ecx
	movl	%edi,%eax
	subl	%esi,%eax
	cmpl	%ecx,%eax
	jb	1f
	cld
	rep
	movsb
	popl	%edi
	popl	%esi
	ret

	ALIGN_TEXT
1:
	addl	%ecx,%edi
	addl	%ecx,%esi
	decl	%edi
	decl	%esi
	std
	rep
	movsb
	popl	%edi
	popl	%esi
	cld
	ret


	SUPERALIGN_TEXT
ENTRY(generic_bcopy)
	pushl	%esi
	pushl	%edi
	movl	12(%esp),%esi
	movl	16(%esp),%edi
	movl	20(%esp),%ecx
	movl	%edi,%eax
	subl	%esi,%eax
	cmpl	%ecx,%eax
	jb	1f
	SUPERALIGN_TEXT
	movl	%ecx,%eax
	shrl	$2,%ecx
	cld
	rep
	movsl
	movl	%eax,%ecx
	andl	$3,%ecx
	rep
	movsb
	popl	%edi
	popl	%esi
	ret
	SUPERALIGN_TEXT
1:
	addl	%ecx,%edi
	addl	%ecx,%esi
	decl	%edi
	decl	%esi
	movl	%ecx,%eax
	andl	$3,%ecx
	std
	rep
	movsb
	movl	%eax,%ecx
	shrl	$2,%ecx
	subl	$3,%esi
	subl	$3,%edi
	rep
	movsl
	popl	%edi
	popl	%esi
	cld
	ret

