#ifndef _MACHINE_FPUDROP_H_
#define _MACHINE_FPUDROP_H_

#ifdef _KERNEL

#include <machine/specialreg.h>
#include "assym.s"


#define	SCHED_PIN(reg)			\
	addl	$1,TD_PINNED(reg)

#define SCHED_UNPIN(reg)		\
	subl	$1,TD_PINNED(reg)

#define UNPIN_JMP(reg, func)		\
CNAME(unpin_jmp_ ## func): ;		\
	SCHED_UNPIN(reg) ;		\
	jmp	generic_ ## func


#define	FPU_DROP(val, func)		\
	cmpl	$val,%ecx ;		\
	jb	generic_ ## func ;	\
	movl	PCPU(CURTHREAD),%eax ;	\
	SCHED_PIN(%eax) ;		\
	btsl	$1,PCPU(FPU_LOCK) ;	\
	jc	unpin_jmp_ ## func ;	\
	movl	TD_SAVEFPU(%eax),%edx ;	\
	pushl	%edx ;			\
	cli ;				\
	cmpl	$0,PCPU(FPCURTHREAD) ;	\
	je	100f ;			\
	fxsave	(%edx) ;		\
	movl	$0,PCPU(FPCURTHREAD) ;	\
	clts ;				\
	fninit ;			\
100:					\
	PCPU_ADDR(SAVEFPU,%edx) ;	\
	movl	%edx,TD_SAVEFPU(%eax) ;	\
	clts ;				\
	movl	%eax,PCPU(FPCURTHREAD) ;\
	sti

#define	FPU_UNDROP			\
	movl	%cr0,%eax ;		\
	orb	$CR0_TS,%al ;		\
	movl	%eax,%cr0 ;		\
	popl	%edx ;			\
	movl	PCPU(CURTHREAD),%eax ;	\
	movl	%edx,TD_SAVEFPU(%eax) ;	\
	movl	$0,PCPU(FPCURTHREAD) ;	\
	movl	$0,PCPU(FPU_LOCK);	\
	SCHED_UNPIN(%eax)

#endif

#endif /* !_MACHINE_FPUDROP_H_ */
